<?php

/* 30.09.20 - Webbax | TUTO 64 */

$root_folder = dirname(__FILE__).'/../../';
require($root_folder.'config/config.inc.php');
$token = Tools::getValue('token');

if($token!='3615'){
    die('bad token');
}

$nb_img = 0;
$products = Db::getInstance()->executeS('SELECT * FROM '._DB_PREFIX_.'product WHERE `active`=1');

foreach($products as $p){
    $image = Product::getCover($p['id_product']);
    $file = dirname(__FILE__).'/../../img/p/'.Image::getImgFolderStatic($image['id_image']).$image['id_image'].'-home_default.jpg';
    $nb_img++;
    if(file_exists($file)){
        //echo "Le fichier $file existe.";
        $file_webp = (dirname(__FILE__).'/webp-img/'.$p['id_product'].'.webp');
        //dump($file_webp);
        jcphp01_generate_webp_image($file, $file_webp, 60);
    }else{
        //echo "Le fichier $file n'existe pas.";
    }
    $nb_img++;

}
echo 'Check sur '.$nb_img.' images';


/* fonction externe */

/**
 * Generate Webp image format
 * 
 * Uses either Imagick or imagewebp to generate webp image
 * 
 * @param string $file Path to image being converted.
 * @param int $compression_quality Quality ranges from 0 (worst quality, smaller file) to 100 (best quality, biggest file).
 * 
 * @return false|string Returns path to generated webp image, otherwise returns false.
 */
function jcphp01_generate_webp_image($file,$output_file, $compression_quality = 80)
{
    // check if file exists
    if (!file_exists($file)) {
        return false;
    }

    // If output file already exists return path
    //$output_file = $file . '.webp';
    if (file_exists($output_file)) {
        return $output_file;
    }

    $file_type = strtolower(pathinfo($file, PATHINFO_EXTENSION));

    if (function_exists('imagewebp')) {

        switch ($file_type) {
            case 'jpeg':
            case 'jpg':
                $image = imagecreatefromjpeg($file);
                break;

            case 'png':
                $image = imagecreatefrompng($file);
                imagepalettetotruecolor($image);
                imagealphablending($image, true);
                imagesavealpha($image, true);
                break;

            case 'gif':
                $image = imagecreatefromgif($file);
                break;
            default:
                return false;
        }

        // Save the image
        $result = imagewebp($image, $output_file, $compression_quality);
        if (false === $result) {
            return false;
        }

        // Free up memory
        imagedestroy($image);

        return $output_file;
    } elseif (class_exists('Imagick')) {
        $image = new Imagick();
        $image->readImage($file);

        if ($file_type === 'png') {
            $image->setImageFormat('webp');
            $image->setImageCompressionQuality($compression_quality);
            $image->setOption('webp:lossless', 'true');
        }

        $image->writeImage($output_file);
        return $output_file;
    }

    return false;
}